/*************************************************************************
 *
 * HTCd - Copyright (C) 1998-2006 Henrik Rydberg
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

#include <hdb/db.h>
#include <mt/lock.h>

static fp_stream mout(stdout),merr(stderr);

main(int argc,char* argv[]) throw(merror_t) try
{
  if(argc<2) {
    merr<<"Usage: "<<argv[0]<<" <db> [<index> <cp>]\n";
    return -1;
  }
  mstring newfile=argv[1];
  mstring oldfile=newfile+sref(".bak");
  rename(newfile.c_str(),oldfile.c_str());
  dbmap db;
  try {
    db.Open(oldfile);
    if(argc>3) db.Sort(sref(argv[2]),sref(argv[3]));
    db.Saveas(newfile);
  }
  catch(const merror_t& e) {
    merr<<"Opened as newfile, old version\n";
    db.Open(newfile,1);
    Convert(db,oldfile.c_str());
  }
  return 0;
}
catch(const merror_t& e) {
  merr<<e.desc<<"\n";
  return -1;
}
