/*************************************************************************
 *
 * HTCd - Copyright (C) 1998-2006 Henrik Rydberg
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

#include "tables.h"
#include "input.h"
#include <unistd.h>

static fp_stream merr(stderr);

main(int argc,char* argv[])
{
  if(argc<2) {
    merr<<"Usage: "<<argv[0]<<" <hdb> [exclusive]\n";
    return -1;
  }
  char* path=argv[1];
  int excl=argc>2?atoi(argv[2]):0;
  mstring err;
  sleep(1);
  InitCurses();
  Tables tab;
  try {
    tab.Open(path,excl);
    tab.Setup(20);
    tab.Navigate();
  }
  catch(const merror_t& e) {
    err=e.desc;
  }
  catch(...) {
    err="hdb: Unexpected error";
  }
  tab.Close();
  EndCurses();
  if(err.nempty()) {
    merr<<err<<"\n";
    sleep(2);
  }
  return 0;
}
