/*************************************************************************
 *
 * HTCd - Copyright (C) 1998-2006 Henrik Rydberg
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

#include <http/mime.h>

HTTP::HTTP()
{
  connect="close";
  pragma="no-cache";
  date=httpTime(idate=Now());
}

int HTTP::Special(sref line)
{
  return 1;
}

int HTTP::Handle(const sref& name,
                 const sref& rawval,
                 const sref& val,
                 const rrpile& opts)
{
  if(Mime::Handle(name,rawval,val,opts)) return 1;
  else if(eqn(name,cache_tag)) cache=val;
  else if(eqn(name,connect_tag)) connect=val;
  else if(eqn(name,date_tag)) date=val;
  else if(eqn(name,pragma_tag)) pragma=val;
  else if(eqn(name,trailer_tag)) trailer=val;
  else if(eqn(name,trans_enc_tag)) trans_enc=val;
  else if(eqn(name,upgrade_tag)) upgrade=val;
  else if(eqn(name,via_tag)) via=val;
  else if(eqn(name,warning_tag)) warning=val;
  else if(eqn(name,allow_tag)) allow=val;
  else if(eqn(name,cont_enc_tag)) cont_enc=val;
  else if(eqn(name,cont_lang_tag)) cont_lang=val;
  else if(eqn(name,cont_location_tag)) cont_location=val;
  else if(eqn(name,cont_md5_tag)) cont_md5=val;
  else if(eqn(name,cont_range_tag)) cont_range=val;
  else if(eqn(name,expires_tag)) expires=val;
  else if(eqn(name,lastmod_tag)) lastmod=val;
  else if(eqn(name,accept_tag)) accept=val;
  else if(eqn(name,accept_charset_tag)) accept_charset=val;
  else if(eqn(name,accept_enc_tag)) accept_enc=val;
  else if(eqn(name,accept_lang_tag)) accept_lang=val;
  else if(eqn(name,accept_range_tag)) accept_range=val;
  else return 0;
  return 1;
}

void HTTP::putHead(mstream& out) const
{
  if(putval(out,cache_tag,cache)) putend(out);
  if(putval(out,connect_tag,connect)) putend(out);
  if(putval(out,date_tag,date)) putend(out);
  if(putval(out,pragma_tag,pragma)) putend(out);
  if(putval(out,trailer_tag,trailer)) putend(out);
  if(putval(out,trans_enc_tag,trans_enc)) putend(out);
  if(putval(out,upgrade_tag,upgrade)) putend(out);
  if(putval(out,via_tag,via)) putend(out);
  if(putval(out,warning_tag,warning)) putend(out);
  if(putval(out,allow_tag,allow)) putend(out);
  if(putval(out,cont_enc_tag,cont_enc)) putend(out);
  if(putval(out,cont_lang_tag,cont_lang)) putend(out);
  if(putval(out,cont_location_tag,cont_location)) putend(out);
  if(putval(out,cont_md5_tag,cont_md5)) putend(out);
  if(putval(out,cont_range_tag,cont_range)) putend(out);
  if(putval(out,expires_tag,expires)) putend(out);
  if(putval(out,lastmod_tag,lastmod)) putend(out);
  if(putval(out,accept_tag,accept)) putend(out);
  if(putval(out,accept_charset_tag,accept_charset)) putend(out);
  if(putval(out,accept_enc_tag,accept_enc)) putend(out);
  if(putval(out,accept_lang_tag,accept_lang)) putend(out);
  if(putval(out,accept_range_tag,accept_range)) putend(out);
  Mime::putHead(out);
}

