/*************************************************************************
 *
 * HTCd - Copyright (C) 1998-2006 Henrik Rydberg
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

#include <mail/res.h>
#include <mime/enc.h>

static fp_stream mout(stdout),merr(stderr);
const mstring multipart="multipart/";

main(int argc,char* argv[]) try
{
  if(argc<2) {
    merr<<"Usage: "<<argv[0]<<" <inbox> [index]\n";
    return -1;
  }
  const char* infile=argv[1];
  Mailbox box;
  GetMessages(box,infile);
  if(argc>2) {
    int m=atoi(argv[2])-1;
    if(m>=0&&m<box.size()) mout<<box[m]<<"\n";
  }
  else {
    merr<<"Read "<<box.size()<<" messages.\n";
    for(int i=0;i<box.size();i++) {
      Message msg(box[i]);
      int multi=msg.cont_type.find(multipart)>=0;
      mout<<"["<<(i+1)<<"]["<<multi<<"]["<<msg.subject<<"]["<<msg.from<<"]\n";
    }
  }
  return 0;
}
catch(const merror_t& e)
{
  fprintf(stderr,"main: %d: %s\n",e.num,e.desc.c_str());
}
