/*************************************************************************
 *
 * HTCd - Copyright (C) 1998-2006 Henrik Rydberg
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

#include <mail/res.h>
#include <mt/lock.h>

static fp_stream mout(stdout),merr(stderr);

main(int argc,char* argv[])
{
  if(argc<3) {
    merr<<"Usage: "<<argv[0]<<" <frombox> <tobox> [indices]\n";
    return -1;
  }
  const char* infile=argv[1];
  const char* outfile=argv[2];
  Mailbox box,keep;
  LockFile(infile);
  LockFile(outfile);
  FILE* outbox=fopen(outfile,"a+");
  if(outbox) {
    GetMessages(box,infile);
    for(int i=0;i<box.size();i++) {
      int move=0;
      if(argc>3) {
        for(int j=3;j<argc;j++) if(atoi(argv[j])-1==i) { move=1; break; }
      }
      else {
        move=1;
      }
      if(move) AppendMessage(outbox,box[i]);
      else keep.push_back(box[i]);
    }
    if(fclose(outbox)) {
      merr<<"Write error: messages kept (but possibly duplicates).\n";
    }
    else {
      PutMessages(keep,infile);
    }
  }
  UnlockFile(outfile);
  UnlockFile(infile);
  return 0;
}
