/*************************************************************************
 *
 * HTCd - Copyright (C) 1998-2006 Henrik Rydberg
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

#include <mt/issue.h>
#include <signal.h>
#include <sys/wait.h>

void issue_t::run(mstream& out,const sref& in) throw(merror_t)
{
  int ip[2],op[2];
  pipe(ip); pipe(op);
  sigignore(SIGPIPE);
  int pid=fork();
  if(pid) {
    close(ip[0]);
    close(op[1]);
    write(ip[1],in.data(),in.size());
    close(ip[1]);
    sref_t buf; int n;
    while((n=read(op[0],buf,sizeof(sref_t)))>0) out.write(buf,n);
    close(op[0]);
    if(wait(0)<0) kill(pid,SIGKILL);
  }
  else {
    close(ip[1]);
    close(op[0]);
    dup2(ip[0],0);
    close(ip[0]);
    dup2(op[1],1);
    close(op[1]);
    execv(*argv(),argv());
    _exit(0);
  }
}

