/*************************************************************************
 *
 * HTCd - Copyright (C) 1998-2006 Henrik Rydberg
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

#include <mt/msmap.h>
#include <algorithm>
using namespace std;

const sref* rrmap::get(const sref& t) const
{
  pair<const_iterator,const_iterator> p=equal_range(begin(),end(),rrstring(t));
  return p.first!=p.second?&p.first->second:0;
}

const sref* rrmap::add(const sref& t,const sref& s)
{
  rrstring tmp(t,s);
  pair<iterator,iterator> p=equal_range(begin(),end(),tmp);
  if(p.first!=p.second) return &(*p.first=tmp).second;
  else return &insert(p.second,tmp)->second;
}

void rrmap::sort()
{
  ::sort(begin(),end());
}

////////////////////////////////////////////////////////////////

int rimap::get(const sref& t) const
{
  pair<const_iterator,const_iterator> p=equal_range(begin(),end(),rimap_t(t));
  return p.first!=p.second?p.first->at:-1;
}

int rimap::add(const sref& t,int at)
{
  rimap_t tmp(t,at);
  pair<iterator,iterator> p=equal_range(begin(),end(),tmp);
  if(p.first!=p.second) return (*p.first=tmp).at;
  else return insert(p.second,tmp)->at;
}

void rimap::sort()
{
  ::sort(begin(),end());
}

////////////////////////////////////////////////////////////////

const mstring* ssmap::get(const mstring& t) const
{
  pair<const_iterator,const_iterator> p=equal_range(begin(),end(),sstring(t));
  return p.first!=p.second?&p.first->second:0;
}

const mstring* ssmap::add(const mstring& t,const mstring& s)
{
  sstring tmp(t,s);
  pair<iterator,iterator> p=equal_range(begin(),end(),tmp);
  if(p.first!=p.second) return &(*p.first=tmp).second;
  else return &insert(p.second,tmp)->second;
}

void ssmap::sort()
{
  ::sort(begin(),end());
}

