/*************************************************************************
 *
 * HTCd - Copyright (C) 1998-2006 Henrik Rydberg
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

#ifndef SERVERH
#define SERVERH

#include <serv/htcd.h>
#include <hdb/buffer.h>
#include <net/isocket.h>
#include <mt/lock.h>
#include <signal.h>

const mstring http_ver="HTTP/";
const double http_minor=1.0,http_major=1.1;

const mstring keep_tag="Keep-Alive";
const mstring close_tag="Close";
const mstring expect_continue_tag="100-continue";

struct htcServ {
  HTCd htcd;
  tokmap user;
  mstring server;
  htcServ(const sref& path);
};

int SendStatus(isocket& out,htcd_req& R,int keep,
               const sref& status,const sref& msg=ms_empty);

#endif
