/*************************************************************************
 *
 * HTCd - Copyright (C) 1998-2006 Henrik Rydberg
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

#include <ops/operator.h>
#include <algorithm>
using namespace std;

void opmap::clear() {
  for(iterator p=begin();p!=end();p++) delete *p;
  mrvec<opmap_t>::clear();
}
void opmap::erase(iterator p) {
  delete *p; mrvec<opmap_t>::erase(p);
}

const op_t* opmap::get(const sref& t) const
{
  pair<const_iterator,const_iterator> p=
    equal_range(begin(),end(),(opmap_t)0,comp_t(t));
  return p.first!=p.second?*p.first:0;
}

const op_t* opmap::add(op_t* op)
{
  pair<iterator,iterator> p=equal_range(begin(),end(),(opmap_t)0,comp_t(op->name));
  if(p.first!=p.second) { delete *p.first; return *p.first=op; }
  else return *insert(p.second,op);
}
