/*************************************************************************
 *
 * HTCd - Copyright (C) 1998-2006 Henrik Rydberg
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

#ifndef HTCdH
#define HTCdH

#include <serv/tempmap.h>
#include <sh/htc.h>
#include <http/http.h>

///////////////////////////////////////////////////

struct HTCd : public HTC {
  fp_stream logger,errlog;
  mstring bindroot;
  mutex_t mutex;
  
  HTCd(const mstring& path);
  ~HTCd();
};

///////////////////////////////////////////////////

struct htcd_user : public htc_user {
  htcd_user(tokmap& p,const mstring& path);
};

///////////////////////////////////////////////////

struct tcpReq {
  IPnode node;
  int port;
};

///////////////////////////////////////////////////

struct htcd_req : public htc_req {
  mstream* output;
  tcpReq* tcp;
  httpReq* req;
  httpResp resp;

  HTCd* htcd() { return (HTCd*)glob; }
  
  void AddBody(const sref& body);
  int RootAllowed();
  
  htcd_req(HTCd& g,tokmap& p,mstream& out,tcpReq& trec,httpReq& hrec);
};

inline htcd_req* Reqd(Env& env) throw(merror_t) { return (htcd_req*)env.req; }

///////////////////////////////////////////////////

void Setup(tokmap& user,HTCd& htcd);

#endif

