/*************************************************************************
 *
 * HTCd - Copyright (C) 1998-2006 Henrik Rydberg
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

#include <serv/htcd.h>

TOK_IMPL(req_mime_version) { out<<Reqd(env)->req->mime_version; }
TOK_IMPL(req_cont_type) { out<<Reqd(env)->req->cont_type; }
TOK_IMPL(req_cont_type_charset) { out<<Reqd(env)->req->cont_type_charset; }
TOK_IMPL(req_cont_type_name) { out<<Reqd(env)->req->cont_type_name; }
TOK_IMPL(req_cont_type_boundary) { out<<Reqd(env)->req->cont_type_boundary; }
TOK_IMPL(req_cont_id) { out<<Reqd(env)->req->cont_id; }
TOK_IMPL(req_cont_desc) { out<<Reqd(env)->req->cont_desc; }
TOK_IMPL(req_cont_disp) { out<<Reqd(env)->req->cont_disp; }
TOK_IMPL(req_cont_disp_name) { out<<Reqd(env)->req->cont_disp_name; }
TOK_IMPL(req_cont_disp_file) { out<<Reqd(env)->req->cont_disp_file; }
TOK_IMPL(req_cont_trans_enc) { out<<Reqd(env)->req->cont_trans_enc; }
TOK_IMPL(req_cont_length) { out<<Reqd(env)->req->cont_length; }

TOK_IMPL(req_cache) { out<<Reqd(env)->req->cache; }
TOK_IMPL(req_connect) { out<<Reqd(env)->req->connect; }
TOK_IMPL(req_date) { out<<Reqd(env)->req->date; }
TOK_IMPL(req_pragma) { out<<Reqd(env)->req->pragma; }
TOK_IMPL(req_trailer) { out<<Reqd(env)->req->trailer; }
TOK_IMPL(req_trans_enc) { out<<Reqd(env)->req->trans_enc; }
TOK_IMPL(req_upgrade) { out<<Reqd(env)->req->upgrade; }
TOK_IMPL(req_via) { out<<Reqd(env)->req->via; }
TOK_IMPL(req_warning) { out<<Reqd(env)->req->warning; }
TOK_IMPL(req_allow) { out<<Reqd(env)->req->allow; }
TOK_IMPL(req_cont_enc) { out<<Reqd(env)->req->cont_enc; }
TOK_IMPL(req_cont_lang) { out<<Reqd(env)->req->cont_lang; }
TOK_IMPL(req_cont_location) { out<<Reqd(env)->req->cont_location; }
TOK_IMPL(req_cont_md5) { out<<Reqd(env)->req->cont_md5; }
TOK_IMPL(req_cont_range) { out<<Reqd(env)->req->cont_range; }
TOK_IMPL(req_expires) { out<<Reqd(env)->req->expires; }
TOK_IMPL(req_lastmod) { out<<Reqd(env)->req->lastmod; }

TOK_IMPL(req_method) { out<<Reqd(env)->req->method; }
TOK_IMPL(req_uri) { out<<Reqd(env)->req->uri; }
TOK_IMPL(req_arg) { out<<Reqd(env)->req->arg; }
TOK_IMPL(req_version) { out<<Reqd(env)->req->version; }
TOK_IMPL(req_accept) { out<<Reqd(env)->req->accept; }
TOK_IMPL(req_accept_charset) { out<<Reqd(env)->req->accept_charset; }
TOK_IMPL(req_accept_enc) { out<<Reqd(env)->req->accept_enc; }
TOK_IMPL(req_accept_lang) { out<<Reqd(env)->req->accept_lang; }
TOK_IMPL(req_accept_range) { out<<Reqd(env)->req->accept_range; }
TOK_IMPL(req_auth) { out<<Reqd(env)->req->auth; }
TOK_IMPL(req_expect) { out<<Reqd(env)->req->expect; }
TOK_IMPL(req_from) { out<<Reqd(env)->req->from; }
TOK_IMPL(req_host) { out<<Reqd(env)->req->host; }
TOK_IMPL(req_if_match) { out<<Reqd(env)->req->if_match; }
TOK_IMPL(req_if_mod) { out<<Reqd(env)->req->if_mod; }
TOK_IMPL(req_if_none) { out<<Reqd(env)->req->if_none; }
TOK_IMPL(req_if_range) { out<<Reqd(env)->req->if_range; }
TOK_IMPL(req_if_unmod) { out<<Reqd(env)->req->if_unmod; }
TOK_IMPL(req_max_forwards) { out<<Reqd(env)->req->max_forwards; }
TOK_IMPL(req_proxy) { out<<Reqd(env)->req->proxy; }
TOK_IMPL(req_range) { out<<Reqd(env)->req->range; }
TOK_IMPL(req_referer) { out<<Reqd(env)->req->referer; }
TOK_IMPL(req_te) { out<<Reqd(env)->req->te; }
TOK_IMPL(req_useragent) { out<<Reqd(env)->req->user_agent; }

///////////////////////////////////////////////////////////////////

TOK_IMPL(resp_cookie) {
  Reqd(env)->resp.set_cookies.push_back(cookie_t(env[0],env[1],env.parg(2)));
}
TOK_IMPL(resp_mime_version) { Reqd(env)->resp.mime_version=env[0]; }
TOK_IMPL(resp_cont_type) { Reqd(env)->resp.cont_type=env[0]; }
TOK_IMPL(resp_cont_type_charset) { Reqd(env)->resp.cont_type_charset=env[0]; }
TOK_IMPL(resp_cont_type_name) { Reqd(env)->resp.cont_type_name=env[0]; }
TOK_IMPL(resp_cont_type_boundary) { Reqd(env)->resp.cont_type_boundary=env[0]; }
TOK_IMPL(resp_cont_id) { Reqd(env)->resp.cont_id=env[0]; }
TOK_IMPL(resp_cont_desc) { Reqd(env)->resp.cont_desc=env[0]; }
TOK_IMPL(resp_cont_disp) { Reqd(env)->resp.cont_disp=env[0]; }
TOK_IMPL(resp_cont_disp_name) { Reqd(env)->resp.cont_disp_name=env[0]; }
TOK_IMPL(resp_cont_disp_file) { Reqd(env)->resp.cont_disp_file=env[0]; }
TOK_IMPL(resp_cont_trans_enc) { Reqd(env)->resp.cont_trans_enc=env[0]; }
TOK_IMPL(resp_cont_length) { Reqd(env)->resp.cont_length=env[0]; }

TOK_IMPL(resp_cache) { Reqd(env)->resp.cache=env[0]; }
TOK_IMPL(resp_connect) { Reqd(env)->resp.connect=env[0]; }
TOK_IMPL(resp_date) { Reqd(env)->resp.date=env[0]; }
TOK_IMPL(resp_pragma) { Reqd(env)->resp.pragma=env[0]; }
TOK_IMPL(resp_trailer) { Reqd(env)->resp.trailer=env[0]; }
TOK_IMPL(resp_trans_enc) { Reqd(env)->resp.trans_enc=env[0]; }
TOK_IMPL(resp_upgrade) { Reqd(env)->resp.upgrade=env[0]; }
TOK_IMPL(resp_via) { Reqd(env)->resp.via=env[0]; }
TOK_IMPL(resp_warning) { Reqd(env)->resp.warning=env[0]; }
TOK_IMPL(resp_allow) { Reqd(env)->resp.allow=env[0]; }
TOK_IMPL(resp_cont_enc) { Reqd(env)->resp.cont_enc=env[0]; }
TOK_IMPL(resp_cont_lang) { Reqd(env)->resp.cont_lang=env[0]; }
TOK_IMPL(resp_cont_location) { Reqd(env)->resp.cont_location=env[0]; }
TOK_IMPL(resp_cont_md5) { Reqd(env)->resp.cont_md5=env[0]; }
TOK_IMPL(resp_cont_range) { Reqd(env)->resp.cont_range=env[0]; }
TOK_IMPL(resp_expires) { Reqd(env)->resp.expires=env[0]; }
TOK_IMPL(resp_lastmod) { Reqd(env)->resp.lastmod=env[0]; }

TOK_IMPL(resp_version) { Reqd(env)->resp.version=env[0]; }
TOK_IMPL(resp_status) { Reqd(env)->resp.status=env[0]; }
TOK_IMPL(resp_age) { Reqd(env)->resp.age=env[0]; }
TOK_IMPL(resp_etag) { Reqd(env)->resp.etag=env[0]; }
TOK_IMPL(resp_location) { Reqd(env)->resp.location=env[0]; }
TOK_IMPL(resp_proxy_auth) { Reqd(env)->resp.proxy_authent=env[0]; }
TOK_IMPL(resp_retry) { Reqd(env)->resp.retry=env[0]; }
TOK_IMPL(resp_server) { Reqd(env)->resp.server=env[0]; }
TOK_IMPL(resp_vary) { Reqd(env)->resp.vary=env[0]; }
TOK_IMPL(resp_auth) { Reqd(env)->resp.authent=env[0]; }

TOK_IMPL(resp_accept) { Reqd(env)->resp.accept=env[0]; }
TOK_IMPL(resp_accept_charset) { Reqd(env)->resp.accept_charset=env[0]; }
TOK_IMPL(resp_accept_enc) { Reqd(env)->resp.accept_enc=env[0]; }
TOK_IMPL(resp_accept_lang) { Reqd(env)->resp.accept_lang=env[0]; }
TOK_IMPL(resp_accept_range) { Reqd(env)->resp.accept_range=env[0]; }

///////////////////////////////////////////////////////////////////

TOK_IMPL(resp_getstatus) { out<<Reqd(env)->resp.status; }

///////////////////////////////////////////////////////////////////

TOK_IMPL(andarg) { sref s=Reqd(env)->req->arg; if(s.nempty()) out.put('?')<<s; }

///////////////////////////////////////////////////////////////////

const mstring reqhelp="%Request header entry\n";
const mstring resphelp="%Response header entry; takes one argument\n";
const mstring respgethelp="%Get response header entry\n";
const mstring x_tag="x";

void envAddReq(tokmap& T)
{
  TOK_ADD(req_mime_version,ms_empty,tok_t::PUBLIC,reqhelp);
  TOK_ADD(req_cont_type,ms_empty,tok_t::PUBLIC,reqhelp);
  TOK_ADD(req_cont_type_charset,ms_empty,tok_t::PUBLIC,reqhelp);
  TOK_ADD(req_cont_type_name,ms_empty,tok_t::PUBLIC,reqhelp);
  TOK_ADD(req_cont_type_boundary,ms_empty,tok_t::PUBLIC,reqhelp);
  TOK_ADD(req_cont_id,ms_empty,tok_t::PUBLIC,reqhelp);
  TOK_ADD(req_cont_desc,ms_empty,tok_t::PUBLIC,reqhelp);
  TOK_ADD(req_cont_disp,ms_empty,tok_t::PUBLIC,reqhelp);
  TOK_ADD(req_cont_disp_name,ms_empty,tok_t::PUBLIC,reqhelp);
  TOK_ADD(req_cont_disp_file,ms_empty,tok_t::PUBLIC,reqhelp);
  TOK_ADD(req_cont_trans_enc,ms_empty,tok_t::PUBLIC,reqhelp);
  TOK_ADD(req_cont_length,ms_empty,tok_t::PUBLIC,reqhelp);
  
  TOK_ADD(req_cache,ms_empty,tok_t::PUBLIC,reqhelp);
  TOK_ADD(req_connect,ms_empty,tok_t::PUBLIC,reqhelp);
  TOK_ADD(req_date,ms_empty,tok_t::PUBLIC,reqhelp);
  TOK_ADD(req_pragma,ms_empty,tok_t::PUBLIC,reqhelp);
  TOK_ADD(req_trailer,ms_empty,tok_t::PUBLIC,reqhelp);
  TOK_ADD(req_trans_enc,ms_empty,tok_t::PUBLIC,reqhelp);
  TOK_ADD(req_upgrade,ms_empty,tok_t::PUBLIC,reqhelp);
  TOK_ADD(req_via,ms_empty,tok_t::PUBLIC,reqhelp);
  TOK_ADD(req_warning,ms_empty,tok_t::PUBLIC,reqhelp);
  TOK_ADD(req_allow,ms_empty,tok_t::PUBLIC,reqhelp);
  TOK_ADD(req_cont_enc,ms_empty,tok_t::PUBLIC,reqhelp);
  TOK_ADD(req_cont_lang,ms_empty,tok_t::PUBLIC,reqhelp);
  TOK_ADD(req_cont_location,ms_empty,tok_t::PUBLIC,reqhelp);
  TOK_ADD(req_cont_md5,ms_empty,tok_t::PUBLIC,reqhelp);
  TOK_ADD(req_cont_range,ms_empty,tok_t::PUBLIC,reqhelp);
  TOK_ADD(req_expires,ms_empty,tok_t::PUBLIC,reqhelp);
  TOK_ADD(req_lastmod,ms_empty,tok_t::PUBLIC,reqhelp);
  
  TOK_ADD(req_method,ms_empty,tok_t::PUBLIC,reqhelp);
  TOK_ADD(req_uri,ms_empty,tok_t::PUBLIC,reqhelp);
  TOK_ADD(req_arg,ms_empty,tok_t::PUBLIC,reqhelp);
  TOK_ADD(req_version,ms_empty,tok_t::PUBLIC,reqhelp);
  TOK_ADD(req_accept,ms_empty,tok_t::PUBLIC,reqhelp);
  TOK_ADD(req_accept_charset,ms_empty,tok_t::PUBLIC,reqhelp);
  TOK_ADD(req_accept_enc,ms_empty,tok_t::PUBLIC,reqhelp);
  TOK_ADD(req_accept_lang,ms_empty,tok_t::PUBLIC,reqhelp);
  TOK_ADD(req_accept_range,ms_empty,tok_t::PUBLIC,reqhelp);
  TOK_ADD(req_auth,ms_empty,tok_t::PUBLIC,reqhelp);
  TOK_ADD(req_expect,ms_empty,tok_t::PUBLIC,reqhelp);
  TOK_ADD(req_from,ms_empty,tok_t::PUBLIC,reqhelp);
  TOK_ADD(req_host,ms_empty,tok_t::PUBLIC,reqhelp);
  TOK_ADD(req_if_match,ms_empty,tok_t::PUBLIC,reqhelp);
  TOK_ADD(req_if_mod,ms_empty,tok_t::PUBLIC,reqhelp);
  TOK_ADD(req_if_none,ms_empty,tok_t::PUBLIC,reqhelp);
  TOK_ADD(req_if_range,ms_empty,tok_t::PUBLIC,reqhelp);
  TOK_ADD(req_if_unmod,ms_empty,tok_t::PUBLIC,reqhelp);
  TOK_ADD(req_max_forwards,ms_empty,tok_t::PUBLIC,reqhelp);
  TOK_ADD(req_proxy,ms_empty,tok_t::PUBLIC,reqhelp);
  TOK_ADD(req_range,ms_empty,tok_t::PUBLIC,reqhelp);
  TOK_ADD(req_referer,ms_empty,tok_t::PUBLIC,reqhelp);
  TOK_ADD(req_te,ms_empty,tok_t::PUBLIC,reqhelp);
  TOK_ADD(req_useragent,ms_empty,tok_t::PUBLIC,reqhelp);

  ///////////////////////////////////////////////////////////////

  TOK_ADD(andarg,ms_empty,tok_t::PUBLIC,
          "%Conditional output of argument string\n"
          "%Syntax: \\andarg\n"
          "%\n"
          "%Outputs ?\\req.arg if \\req.arg is non-empty.\n"
          );

  TOK_ADD(resp_cookie,"xx?",tok_t::SYSONLY,
          "%Set cookie\n"
          "%Syntax: \\resp.cookie{name}{val}<options>\n"
          "%\n"
          "%Sets the cookie name to value val\n"
          "%The options field should be on the form expected\n"
          "%in the HTTP header, for instance\n"
          "%domain=something; path=/; expires=http-data\n"
          "%\n"
          "%No newlines should be added, and remember that ; needs\n"
          "%to be escaped.\n"
          );

  ///////////////////////////////////////////////////////////////

  TOK_ADD(resp_mime_version,x_tag,tok_t::SYSONLY,resphelp);
  TOK_ADD(resp_cont_type,x_tag,tok_t::SYSONLY,resphelp);
  TOK_ADD(resp_cont_type_charset,x_tag,tok_t::SYSONLY,resphelp);
  TOK_ADD(resp_cont_type_name,x_tag,tok_t::SYSONLY,resphelp);
  TOK_ADD(resp_cont_type_boundary,x_tag,tok_t::SYSONLY,resphelp);
  TOK_ADD(resp_cont_id,x_tag,tok_t::SYSONLY,resphelp);
  TOK_ADD(resp_cont_desc,x_tag,tok_t::SYSONLY,resphelp);
  TOK_ADD(resp_cont_disp,x_tag,tok_t::SYSONLY,resphelp);
  TOK_ADD(resp_cont_disp_name,x_tag,tok_t::SYSONLY,resphelp);
  TOK_ADD(resp_cont_disp_file,x_tag,tok_t::SYSONLY,resphelp);
  TOK_ADD(resp_cont_trans_enc,x_tag,tok_t::SYSONLY,resphelp);
  TOK_ADD(resp_cont_length,x_tag,tok_t::SYSONLY,resphelp);

  TOK_ADD(resp_cache,x_tag,tok_t::SYSONLY,resphelp);
  TOK_ADD(resp_connect,x_tag,tok_t::SYSONLY,resphelp);
  TOK_ADD(resp_date,x_tag,tok_t::SYSONLY,resphelp);
  TOK_ADD(resp_pragma,x_tag,tok_t::SYSONLY,resphelp);
  TOK_ADD(resp_trailer,x_tag,tok_t::SYSONLY,resphelp);
  TOK_ADD(resp_trans_enc,x_tag,tok_t::SYSONLY,resphelp);
  TOK_ADD(resp_upgrade,x_tag,tok_t::SYSONLY,resphelp);
  TOK_ADD(resp_via,x_tag,tok_t::SYSONLY,resphelp);
  TOK_ADD(resp_warning,x_tag,tok_t::SYSONLY,resphelp);
  TOK_ADD(resp_allow,x_tag,tok_t::SYSONLY,resphelp);
  TOK_ADD(resp_cont_enc,x_tag,tok_t::SYSONLY,resphelp);
  TOK_ADD(resp_cont_lang,x_tag,tok_t::SYSONLY,resphelp);
  TOK_ADD(resp_cont_location,x_tag,tok_t::SYSONLY,resphelp);
  TOK_ADD(resp_cont_md5,x_tag,tok_t::SYSONLY,resphelp);
  TOK_ADD(resp_cont_range,x_tag,tok_t::SYSONLY,resphelp);
  TOK_ADD(resp_expires,x_tag,tok_t::SYSONLY,resphelp);
  TOK_ADD(resp_lastmod,x_tag,tok_t::SYSONLY,resphelp);

  TOK_ADD(resp_version,x_tag,tok_t::SYSONLY,resphelp);
  TOK_ADD(resp_status,x_tag,tok_t::SYSONLY,resphelp);
  TOK_ADD(resp_age,x_tag,tok_t::SYSONLY,resphelp);
  TOK_ADD(resp_etag,x_tag,tok_t::SYSONLY,resphelp);
  TOK_ADD(resp_location,x_tag,tok_t::SYSONLY,resphelp);
  TOK_ADD(resp_proxy_auth,x_tag,tok_t::SYSONLY,resphelp);
  TOK_ADD(resp_retry,x_tag,tok_t::SYSONLY,resphelp);
  TOK_ADD(resp_server,x_tag,tok_t::SYSONLY,resphelp);
  TOK_ADD(resp_vary,x_tag,tok_t::SYSONLY,resphelp);
  TOK_ADD(resp_auth,x_tag,tok_t::SYSONLY,resphelp);

  TOK_ADD(resp_accept,x_tag,tok_t::SYSONLY,resphelp);
  TOK_ADD(resp_accept_charset,x_tag,tok_t::SYSONLY,resphelp);
  TOK_ADD(resp_accept_enc,x_tag,tok_t::SYSONLY,resphelp);
  TOK_ADD(resp_accept_lang,x_tag,tok_t::SYSONLY,resphelp);
  TOK_ADD(resp_accept_range,x_tag,tok_t::SYSONLY,resphelp);

  ///////////////////////////////////////////////////////////////

  TOK_ADD(resp_getstatus,ms_empty,tok_t::PUBLIC,respgethelp);
}
