/*************************************************************************
 *
 * HTCd - Copyright (C) 1998-2006 Henrik Rydberg
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

#include <sh/htc.h>

/////////////////////////////////////////////////////////////////

TOK_IMPL(sethost)
{
  Req(env)->htc()->setHost(env[0]);
}
TOK_IMPL(setdomain)
{
  Req(env)->htc()->setDomain(env[0]);
}
TOK_IMPL(setport)
{
  Req(env)->htc()->setPort(atoi(env[0]));
}
TOK_IMPL(setmailer)
{
  Req(env)->htc()->setMailer(env[0]);
}

/////////////////////////////////////////////////////////////////

TOK_IMPL(HOST) {
  out<<Req(env)->htc()->host;
}

TOK_IMPL(HOSTIP) {
  out<<Req(env)->htc()->node.ip;
}

TOK_IMPL(DOMAIN) {
  out<<Req(env)->htc()->domain;
}

TOK_IMPL(ROOT) {
  out<<Req(env)->htc()->username;
  if(Req(env)->htc()->domain.size()) out<<"@"<<Req(env)->htc()->domain;
}

TOK_IMPL(ADMIN) {
  out<<Req(env)->htc()->username;
  if(Req(env)->htc()->domain.size()) out<<"@"<<Req(env)->htc()->domain;
}

TOK_IMPL(port)
{
  out<<Req(env)->htc()->port;
}

/////////////////////////////////////////////////////////////

void envAddNet(tokmap& T)
{
  TOK_ADD(sethost,"x",tok_t::SYSONLY,
          "%Set host name\n"
          "%Syntax: \\sethost{host}\n"
          );
  TOK_ADD(setdomain,"x",tok_t::SYSONLY,
          "%Set default domain\n"
          "%Syntax: \\setdomain{domain}\n"
          );
  TOK_ADD(setport,"x",tok_t::SYSONLY,
          "%Set host port number\n"
          "%Syntax: \\setport{port}\n"
          );
  TOK_ADD(setmailer,"x",tok_t::SYSONLY,
          "%Set mail program path\n"
          "%Syntax: \\setmailer{path}\n"
          );

  /////////////////////////////////////////////////////////////

  TOK_ADD(HOST,"",tok_t::PUBLIC,
          "%Host name\n"
          "%Syntax: \\HOST\n"
          );

  TOK_ADD(HOSTIP,"",tok_t::PUBLIC,
          "%Host IP address\n"
          "%Syntax: \\HOSTIP\n"
          );

  TOK_ADD(DOMAIN,"",tok_t::PUBLIC,
          "%Default domain\n"
          "%Syntax: \\DOMAIN\n"
          );

  TOK_ADD(ROOT,"",tok_t::PUBLIC,
          "%htcroot email address\n"
          "%Syntax: \\ROOT\n"
          );

  TOK_ADD(ADMIN,"",tok_t::PUBLIC,
          "%admin email address\n"
          "%Syntax: \\ADMIN\n"
          );

  TOK_ADD(port,"",tok_t::PUBLIC,
          "%Host port number\n"
          "%Syntax: \\port\n"
          );
}
